// PC - Mouse Functions

#include "sysconfig.h"
#include "sysdeps.h"
#include "config.h"
#include "options.h"
#include "custom.h"
#include "Memory.h"
#include "newcpu.h"
#include "Mouse.h"
#include "Native.h"
#include "VIA.h"
#include "SCC.h"
#ifdef _Mouse_Debug
#include <stdio.h>
#endif

UBYTE X2 = 0;
UBYTE Y2 = 0;

extern volatile int mouse_x, mouse_y;
extern volatile int buttonstate;
volatile int lastmx, lastmy;

int OldX = 0, OldY = 0;

void Mouse_Update(void)
{
    int CurX, CurY;
    int DiffX, DiffY;
    extern SCC_Ty SCC;
    int PosX = 0;
    int PosY = 0;
    int LastX = 0;
    int LastY = 0;
    int ChangeX = 1;
    int ChangeY = 1;
    int SkipX = 0;
    int SkipY = 0;
    int i, Count;

    CurX = mouse_x;
    CurY = mouse_y;

    if (CurX != OldX)
	if (CurX < OldX)
	    X2 = 1;		// Moving Right

	else
	    X2 = 0;		// Moving Left

    if (CurY != OldY)
	if (CurY < OldY)
	    Y2 = 0;		// Moving Down

	else
	    Y2 = 1;		// Moving Up

    DiffX = abs(CurX - OldX);
    DiffY = abs(CurY - OldY);

    if (DiffX > DiffY) {
	Count = DiffX;
	SkipY = 1;
    } else {
	Count = DiffY;
	SkipX = 1;
    }

    while (DiffX || DiffY) {
        if (DiffX)		// Did Mouse move X direction?
            if ((SCC.A.WR[15] & 0x08) == 0x08)	// DCD Interrupts Enabled
	    {
                SCC.A.RR[0] |= 0x08;	// DCD = 1
                SCC.A.RR[3] |= 0x08;	// Channel A DCD Interrupt Occured
	    }
        if (DiffY)		// Did Mouse move Y direction?
            if ((SCC.B.WR[15] & 0x08) == 0x08)	// DCD Interrupts Enabled
	    {
                SCC.B.RR[0] |= 0x08;	// DCD = 1
                SCC.A.RR[3] |= 0x01;	// Channel B DCD Interrupt Occured
            }
        if (DiffX)
            if ((SCC.A.WR[9] & 0x10) == 0)	// Status is Low
            {
                SCC.B.RR[2] &= 0xF1;	// 1111 0001 Mask
                SCC.B.RR[2] |= 0x0A;	// 0000 1010 External/Status Change on Port A
            } else		// Status is high
            {
                SCC.B.RR[2] &= 0x8F;	// 1000 1111 Mask
                SCC.B.RR[2] |= 0x50;	// 0101 0000 External/Status Change on Port A
            } else if (DiffY)
                if ((SCC.A.WR[9] & 0x10) == 0)	// Status is Low
                {
                    SCC.B.RR[2] &= 0xF1;  // 1111 0001 Mask
                    SCC.B.RR[2] |= 0x02;  // 0000 0010 External/Status Change on Port B
                } else		// Status is high
                {
                    SCC.B.RR[2] &= 0x8F;	// 1000 1111 Mask              
                    SCC.B.RR[2] |= 0x40;	// 0100 0000 External/Status Change on Port B
                }
                if ((SCC.A.WR[9] & 0x08) == 0x08)   // Master Interrupts Enabled
                    if (regs.intmask <= 2)
                        Exception(26);	// SCC Interrupt Occured

        if (DiffX)
            DiffX--;
        if (DiffY)
            DiffY--;
    }

    OldX = CurX;
    OldY = CurY;
}

// VIA Interface Functions

UBYTE VIA_GORB5(void)		// Mouse Y2
 {
    return Y2;
}

UBYTE VIA_GORB4(void)		// Mouse X2
 {
    return X2;
}

UBYTE VIA_GORB3(void)		// Mouse Button
 {
    //#ifdef _Mouse_Debug
    //return 0;
    //#endif
#ifdef _MacOS
    if (Button()) {
	return 0;
    }				// Mouse Button Down

    else {
	return 1;
    }				// Mouse Button Up
#endif
    return !buttonstate;
    return 1;			// Default = Up

}

void VIA_PORB5(UBYTE Data)
{
#ifdef _VIA_Interface_Debug
    printf("VIA ORB5 attempts to be an output\n");
#endif
}

void VIA_PORB4(UBYTE Data)
{
#ifdef _VIA_Interface_Debug
    printf("VIA ORB4 attempts to be an output\n");
#endif
}

void VIA_PORB3(UBYTE Data)
{
#ifdef _VIA_Interface_Debug
    printf("VIA ORB3 attempts to be an output\n");
#endif
}
