/* vMac 0.1 Source
   By Philip Cummins (PC)
   Copyright PC 1997 */

/* PC - Interrupt Functions */

#include "sysconfig.h"
#include "sysdeps.h"
#include "config.h"
#include "custom.h"
#include "VIA.h"
#include "VIA_Interrupts.h"
#include "VIA_Interface.h"
#include "Screen.h"
#include "RTC.h"
#include "Mouse.h"
/*
   #include <LowMem.h>
 */

static long int Instruction_Counter = 0;
static int VBL_Counter = 0;
static long int Mouse_Counter = 0;
static int VIA_Counter = 0;

int Interrupt_Init(void)
{
    Instruction_Counter = 0;
    VIA_Counter = 0;
    Mouse_Counter = 0;
    VBL_Counter = 0;
    return 0;
}

void Interrupt_Reset(void)
{
    (void) Interrupt_Init();
}

void Interrupt_Timing(void)
{
    Instruction_Counter += 1;
    VIA_Counter += 1;
#ifdef _MacOS
#ifdef _Mouse_Enabled
    Mouse_Counter += 1;

    //if ((Mouse_Counter % 1000) == 0) // Arbitary value, test
    //{
    //  Mouse_Update2();
    //  Mouse_Counter = 0;
    //}
#endif
#endif

    // Clock = 7833600 Hz (7.8336 mHz)
    // At best, we can get 3916800 instructions per second
    // Normally, it's probably a lot lower than that, say
    // 783360 instructions/sec if there's 10 cycles per instr.

    if ((VIA_Counter % 4) == 0) {
	VIA_Counter = 0;
	VIA_Timer();
    }
    if ((Instruction_Counter % 32640) == 0) {
	Screen_Draw();
	//Mouse_Update();
	Instruction_Counter = 0;
	VBL_Counter += 1;
	VIA_Int(Vertical_Blanking);
	if ((VBL_Counter % 60) == 0) {
	    VBL_Counter = 0;
	    Sony_Update();
	    RTC_Interrupt();
	    VIA_Int(One_Second);
	}
    }
}
